; a0 = music
load_music:
	movem.l	a0/a1/d1/d2/d0,-(a7)
	if(def(__proggy_start))
		move.l	(a5),a0				; For BasiEgaXorz
	endif
	bsr	load_fm_driver
	move.l	a1,d1
	sub.l	#$A00000,d1
	move.w	(a0)+,d2
	add.w	d1,d2
	add.w	#3,d2
	move.b	d2,($A00000+$10)
	lsr.w	#8,d2
	move.b	d2,($A00000+$11)
	move.w	#8191,d0
	sub.w	d1,d0
;	move.b	#0,(a1)+
@2:
	move.b	(a0)+,(a1)+
	dbra	d0,@2
	bsr	z80_reset
	bsr	fm_wait
	move.b	#$B4,$A04000
	move.b	#$C0,$A04001
	bsr	fm_wait
	move.b	#$B4,$A04002
	move.b	#$C0,$A04003
	movem.l	(a7)+,a0/a1/d1/d2/d0
	rts

load_instrument:
	movem.l	a0/a1/d1/d2/d0,-(a7)
	clr.l	d0
	if(def(__proggy_start))				; For BasiEgaXorz
		move.l	(a5),d0
		move.l	4(a5),a0
	endif

	divu	#3,d0
	clr.l	d1
	move.b	d0,d1
	lsl.l	#1,d1
	move.l	#$A04000,a1
	add.l	d1,a1
	swap	d0
	move.w	(a0)+,d1
@1:
	bsr	fm_wait
	move.b	d0,d2
	add.b	(a0)+,d2
	move.b	d2,0(a1)
	move.b	(a0)+,1(a1)
	subq.w	#1,d1
	bne	@1
	movem.l	(a7)+,a0/a1/d1/d2/d0
	rts

fm_wait:
	btst.b	#7,($A04000)
	bne	fm_wait
	btst.b	#7,($A04000)
	bne	fm_wait
	rts

z80_stop:
	move.w	#$100,($A11200)
	move.w	#$100,($A11100)
z80_wait:
	btst.b	#8,($A11100)
	bne	z80_wait
	rts

z80_reset:
	move.w	#$000,($A11200)
	nop
	nop
	nop
	nop
	move.w	#$100,($A11200)
	rts

z80_start:
        move.w  #$000,($A11100)
	rts

fm_silence:
	movem.l	a0/a1/a2,-(a7)
	lea	$A04000,a0
	lea	@1(PC),a1
	lea	6(a1),a2
@2:
	bsr	fm_wait
	move.b	#$28,(a0)
	move.b	(a1)+,1(a0)
	cmp.l	a1,a2
	bne	@2
	movem.l	(a7)+,a0/a1/a2
	rts
@1:	dc.b	$00,$01,$02,$04,$05,$06

; Returns a1 as last byte sent in z80 memory
load_fm_driver:
	movem.l	a0/d0,-(a7)
	lea     @2(PC),a0
	lea     $A00000,a1
	move.w  #@3-@2-1,d0
@1:
	move.b  (a0)+,(a1)+
	dbra	d0,@1
	movem.l	(a7)+,a0/d0
	rts
@2:
	if(def(__proggy_start))
		incbin	slibrary\fmz187.bin		; For Basiegaxorz
	else
		incbin	fmz187.bin			; For SNASM
	endif
@3:
	EVEN


